// Metrics -- 1 - Twips only
/*
     PAGEN.CC 
     Programmer: Ken Mayer
     Date......: 02/20/1998   

     This is a copy of the 'report.cc' file that ships with 
     Visual dBASE, this version checks for _app.nPagePlus -- 
     a value that is added to the form's reportPage value -- 
     if this value exists, it is used, otherwise, we just work 
     like normal.

     To use this, determine what you want the report's first
     page number to be -- example -- 25. Subtract one from it.
     Store that value to _app.nPagePlus:

     _app.nPagePlus = 24 // 25-1
     // execute your report:
     do myrep.rep 
     // clear out the value in nPagePlus:
     _app.nPagePlus = null

      (To place it on a report, in the command window:

       set procedure to pagen.cc additive

       and it will now appear in the custom tab of the control
       palelette. Place it on your report where you want the
       page number to be printed. If you haven't set _app.nPagePlus
       the first page will appear in the designer as 1, but 
       once you set that value, then the appropriate change
       will occur ... )

*/
class pageNumberPlus(ParentObj) of Text(ParentObj) custom 
   SET TALK OFF
   with ( this )
      height   := 200
      width    := 1000
      metric   := 1 // twips
      fontSize := 8
      text     := class::pageValue
   endwith

   function pageValue 
      // returns 0 if placed on form
      local nPage
      nPage = 0
      if TYPE("this.form.reportPage") == "N" 
         nPage := this.form.reportPage
      endif
      // here's the additional code:
      if TYPE("_app.nPagePlus" ) == "N"
         nPage += _app.nPagePlus
      endif
   return ( nPage )

endclass



